-- Stores the last modification time
g_Shadow4_File_Last_Modification = nil

--
-- This is the initialization function. It gets called every time Rainlendar
-- is started or refreshed. The initialization function must be defined in the
-- skin file.
--
function Shadow4_File_Initialize(skin, window)
  Rainlendar_CreateTimer(1000, Shadow4_File_OnTimer, skin .. "|" .. window)
  Shadow4_File_UpdateFile(skin .. "|" .. window)
end

function Shadow4_File_UpdateFile(userData)
  _, _, skin, window = userData:find("(.*)|(.*)")

  -- Erase the existing items  
  Rainlendar_SetItemValue(window, "TextFile.list", "list", "")

  path = Rainlendar_GetVariable(skin, window, "File_path")
  _, _, name = path:find(".*/(.*)")
  if name == nil then
    _, _, name = path:find(".*\\(.*)")
  end

  pos = 1
  Rainlendar_SetItemValue(window, "TextFile.list", "list." .. pos .. ".type", "1")
  if name == "" or name == nil then
    Rainlendar_SetItemValue(window, "TextFile.list", "list." .. pos .. ".text", Rainlendar_GetString("No file given"))
    pos = pos + 1
    Rainlendar_SetItemValue(window, "TextFile.list", "list." .. pos .. ".text", Rainlendar_GetString("Go to the window's settings and point the path variable to a text file."))
  else
    Rainlendar_SetItemValue(window, "TextFile.list", "list." .. pos .. ".text", "[[" ..path .. "][" .. name .. "]]")

    content = Rainlendar_ReadFile(path)
    pos = pos + 1
    Rainlendar_SetItemValue(window, "TextFile.list", "list." .. pos .. ".text", content)
  end

  Rainlendar_Redraw(1, window)
end

--
-- A callback function for the timer. This gets called every time the timer triggers.
-- Returns true so the timer will go on forever (false would stop the timer).
--
function Shadow4_File_OnTimer(userData)
  _, _, skin, window = userData:find("(.*)|(.*)")

  -- Poll the file for changes  
  path = Rainlendar_GetVariable(skin, window, "File_path")
  if path then
    info = lfs.attributes(path)
    if info then
      if g_Shadow4_File_Last_Modification then
        if g_Shadow4_File_Last_Modification < info["modification"] then
          g_Shadow4_File_Last_Modification = info["modification"]
          Shadow4_File_UpdateFile(userData)
        end
      else
        g_Shadow4_File_Last_Modification = info["modification"]
      end
    end
  end

  return True
end
